<?php

// /**
//  * BACK END GROUP
//  */
// array_insert($GLOBALS['BE_MOD'], 1, array('popupmanager'=>array()));
// 
// /**
//  * BACK END MODULES
//  */
// array_insert($GLOBALS['BE_MOD'], 1, [
//     'popupmanager' => [
//         'popups' => [
//             'tables' => ['tl_popup_set', 'tl_popup', 'tl_content']
//         ]
//     ]
// ]);

use CreoCode\ContaoPopup\Models\PopupModel;
use CreoCode\ContaoPopup\Models\PopupSetModel;

/**
 * BACK END MODULES
 */
$GLOBALS['BE_MOD']['content']['popups'] = array(
    'tables' => ['tl_popup_set', 'tl_popup', 'tl_content']
);


/**
 * Add Files
 */
if (TL_MODE == 'BE') {
    $GLOBALS['TL_CSS'][] = 'bundles/contaopopup/css/backend.css';
    $GLOBALS['TL_CSS'][] = 'bundles/contaopopup/css/animate.min.css';
    $GLOBALS['TL_JAVASCRIPT'][] = 'bundles/contaopopup/js/backend.js|async';
}


/**
 * Hooks
 */
$GLOBALS['TL_HOOKS']['generatePage'][] = array('CreoCode\ContaoPopup\Classes\GeneratePage', 'addScripts');
$GLOBALS['TL_HOOKS']['outputFrontendTemplate'][] = array('CreoCode\ContaoPopup\Classes\GeneratePage', 'addPopups');

/**
 * Register Models
 */
$GLOBALS['TL_MODELS'][PopupModel::getTable()] = PopupModel::class;
$GLOBALS['TL_MODELS'][PopupSetModel::getTable()] = PopupSetModel::class;

/**
 * Add permissions
 */
$GLOBALS['TL_PERMISSIONS'][] = 'popups';
$GLOBALS['TL_PERMISSIONS'][] = 'popupsp';

/**
 * Animations for the template
 */
$GLOBALS['tl_popup']['animationsInDefault'] = 'fadeIn';
$GLOBALS['tl_popup']['animationsIn'] = array(
	'attentionSeekers' => array(
		'bounce' => 'bounce', 
		'flash' => 'flash', 
		'pulse' => 'pulse', 
		'rubberBand' => 'rubberBand', 
		'shake' => 'shake', 
		'swing' => 'swing', 
		'tada' => 'tada', 
		'wobble' => 'wobble'
	),
    'bouncingEntrances' => array(
    	'bounceIn' => 'bounceIn',
		'bounceInDown' => 'bounceInDown',
		'bounceInLeft' => 'bounceInLeft',
		'bounceInRight' => 'bounceInRight',
		'bounceInUp' => 'bounceInUp'
 	),
    'fadingEntrances' => array(
    	'fadeIn' => 'fadeIn',
		'fadeInDown' => 'fadeInDown',
		'fadeInDownBig' => 'fadeInDownBig',
		'fadeInLeft' => 'fadeInLeft',
		'fadeInLeftBig' => 'fadeInLeftBig',
		'fadeInRight' => 'fadeInRight',
		'fadeInRightBig' => 'fadeInRightBig',
		'fadeInUp' => 'fadeInUp',
		'fadeInUpBig' => 'fadeInUpBig'
	),
    'flipperEntrances' => array(
    	'flip' => 'flip',
		'flipInX' => 'flipInX',
		'flipInY' => 'flipInY'
	),
    'lightspeedEntrances' => array(
    	'lightSpeedIn' => 'lightSpeedIn'
    ),
    'rotatingEntrances' => array(
    	'rotateIn' => 'rotateIn',
		'rotateInDownLeft' => 'rotateInDownLeft',
		'rotateInDownRight' => 'rotateInDownRight',
		'rotateInUpLeft' => 'rotateInUpLeft',
		'rotateInUpRight' => 'rotateInUpRight'
	),
    'slidingEntrances' => array(
    	'slideInUp' => 'slideInUp',
		'slideInDown' => 'slideInDown',
		'slideInLeft' => 'slideInLeft',
		'slideInRight' => 'slideInRight'
 	),
    'zoomEntrances' => array(
    	'zoomIn' => 'zoomIn',
		'zoomInDown' => 'zoomInDown',
		'zoomInLeft' => 'zoomInLeft',
		'zoomInRight' => 'zoomInRight',
		'zoomInUp' => 'zoomInUp'
	),
    'specials' => array(
    	'hinge' => 'hinge',
		'jackInTheBox' => 'jackInTheBox',
		'rollIn' => 'rollIn',
		'rollOut' => 'rollOut'
	),
);
$GLOBALS['tl_popup']['animationsOutDefault'] = 'fadeOut';
$GLOBALS['tl_popup']['animationsOut'] = array(
    'attentionSeekers' => array(
        'bounce' => 'bounce',
        'flash' => 'flash',
        'pulse' => 'pulse',
        'rubberBand' => 'rubberBand',
        'shake' => 'shake',
        'swing' => 'swing',
        'tada' => 'tada',
        'wobble' => 'wobble'
    ),
    'bouncingExits' => array(
        'bounceOut' => 'bounceOut',
        'bounceOutDown' => 'bounceOutDown',
        'bounceOutLeft' => 'bounceOutLeft',
        'bounceOutRight' => 'bounceOutRight',
        'bounceOutUp' => 'bounceOutUp'
    ),
    'fadingExits' => array(
        'fadeOut' => 'fadeOut',
        'fadeOutDown' => 'fadeOutDown',
        'fadeOutDownBig' => 'fadeOutDownBig',
        'fadeOutLeft' => 'fadeOutLeft',
        'fadeOutLeftBig' => 'fadeOutLeftBig',
        'fadeOutRight' => 'fadeOutRight',
        'fadeOutRightBig' => 'fadeOutRightBig',
        'fadeOutUp' => 'fadeOutUp',
        'fadeOutUpBig' => 'fadeOutUpBig'
    ),
    'flipperExits' => array(
        'flip' => 'flip',
        'flipOutX' => 'flipOutX',
        'flipOutY' => 'flipOutY'
    ),
    'lightspeedExits' => array(
        'lightSpeedOut' => 'lightSpeedOut'
    ),
    'rotatingExits' => array(
        'rotateOut' => 'rotateOut',
        'rotateOutDownLeft' => 'rotateOutDownLeft',
        'rotateOutDownRight' => 'rotateOutDownRight',
        'rotateOutUpLeft' => 'rotateOutUpLeft',
        'rotateOutUpRight' => 'rotateOutUpRight'
    ),
    'slidingExits' => array(
        'slideOutUp' => 'slideOutUp',
        'slideOutDown' => 'slideOutDown',
        'slideOutLeft' => 'slideOutLeft',
        'slideOutRight' => 'slideOutRight'
    ),
    'zoomExits' => array(
        'zoomOut' => 'zoomOut',
        'zoomOutDown' => 'zoomOutDown',
        'zoomOutLeft' => 'zoomOutLeft',
        'zoomOutRight' => 'zoomOutRight',
        'zoomOutUp' => 'zoomOutUp'
    ),
    'specials' => array(
        'hinge' => 'hinge',
        'jackInTheBox' => 'jackInTheBox',
        'rollOut' => 'rollOut',
        'rollOut' => 'rollOut'
    ),
);